package com.glxp.udidl.admin.service.tyapi;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.glxp.udidl.admin.entity.tyapi.TyContactInfoEntity;
import com.glxp.udidl.admin.res.tyapi.SupplierResponse;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.glxp.udidl.admin.entity.tyapi.TySupplierEntity;
import com.glxp.udidl.admin.dao.tyapi.TySupplierMapper;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
public class TySupplierService extends ServiceImpl<TySupplierMapper, TySupplierEntity> {
    @Resource
    TyDlHttpClient tyDlHttpClient;
    @Resource
    TySupplierMapper tySupplierMapper;

    public List<TySupplierEntity> download(String hospital) {
        Integer pageNum = 1;
        Integer pageSize = 20;
        if (tySupplierMapper.exists(new QueryWrapper<TySupplierEntity>().eq("hospName", hospital))) {
            log.error(hospital + "供应商列表已存在重复下载！");
        } else {
            while (true) {
                SupplierResponse supplierResponse = tyDlHttpClient.getSupplier(hospital, pageNum, pageSize);
                if (supplierResponse.getErrorCode() == 0) {
                    List<SupplierResponse.ResultDTO.PageBeanDTO.SupplierDTO> supplierDTOS = supplierResponse.getResult().getPageBean().getResult();
                    List<TySupplierEntity> tySupplierEntities = BeanUtil.copyToList(supplierDTOS, TySupplierEntity.class);
                    if (CollUtil.isNotEmpty(supplierDTOS)) {
                        for (TySupplierEntity tySupplierEntity : tySupplierEntities) {
                            tySupplierEntity.setHospName(hospital);
                            tySupplierEntity.setUpdateTime(new Date());
                        }
                    }
                    tySupplierMapper.insertBatch(tySupplierEntities);
                    if (CollUtil.isNotEmpty(supplierDTOS) && supplierDTOS.size() == 20) {
                        pageNum = pageNum + 1;
                    } else {
                        break;
                    }
                }
            }
        }
        List<TySupplierEntity> tySupplierEntities = tySupplierMapper.selectList(new QueryWrapper<TySupplierEntity>().eq("hospName", hospital));
        return tySupplierEntities;
    }


}
